#!/usr/bin/perl -w

use POSIX;

my $spr2pc = '../spr2pc' || die "can't find spr2pc";
my $filename = $ARGV[0] || '/mnt/floppy/open/opntex.bin';
my $output = $ARGV[1] || '/home/greerga/www/fft/open/opntex{}.gif';
my $size = (-s $filename);

open(DATA, "<$filename") || die "can't open $filename";

my @offs = (0,34816,69632,137216,172032,206848,241664,288768,335872,382976,430080,477184,524288,571392,618496,665600,712704,759808,806912,854016,901120,948224);

my $count = 0;
foreach $offset (@offs) {
  sysseek(DATA, $offset, SEEK_SET);
  sysread(DATA, $header, 20);
  my @header = unpack("S*", $header);

  sysseek(DATA, $offset + $header[4] + 8, SEEK_SET);
  sysread(DATA, $footer, 12);
  my @footer = unpack("S*", $footer);

  $footer[0] += 65536 if ($footer[0] < 32768);
  my $splitvalue = $footer[4] * 2;
  my $palette = $offset + 20;
  my $pictoff = $offset + $header[4] + 20;
  my $palres = $header[8] * 2;
  my $pictsize = $footer[0];

  my $out;
  ($out = $output) =~ s/{}/sprintf "%02d", $count++/e;

  my $exec = "$spr2pc -z 1:1:1 -l $splitvalue -a $palette -j $pictoff:$pictsize $filename -o $out -r 0:$palres -vv @ARGV[1..$#ARGV]";
  print $exec, "\n";
  system($exec);
}
